"
 COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ModalBox subclass:#InfoBox
       instanceVariableNames:'formLabel textLabel okButton okAction'
       classVariableNames:'InfoBitmap'
       poolDictionaries:''
       category:'Views-Interactors'
!

InfoBox comment:'

COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

this class implements a pop-up box to show an information message

$Header: /cvs/stx/stx/libwidg/InfoBox.st,v 1.2 1993-10-13 01:02:38 claus Exp $
written Spring/Summer 89 by claus
'!

!InfoBox class methodsFor:'instance creation'!

title:titleString
    "create a new infoBox with title, aTitleString"

    ^ (self new) title:titleString
! !

!InfoBox methodsFor:'initialization'!

initialize
    super initialize.

    InfoBitmap isNil ifTrue:[
        InfoBitmap := Form fromFile:'Information.xbm' resolution:100 on:device
    ].

    formLabel := Label in:self.
    self initFormBitmap.
    formLabel borderWidth:0.
    formLabel origin:(ViewSpacing @ ViewSpacing).

    textLabel := Label label:'Information' in:self.
    textLabel borderWidth:0.
    textLabel origin:((ViewSpacing + formLabel width + ViewSpacing) @ ViewSpacing).

    okButton := Button label:(resources at:'ok')
                       action:[
                                okButton turnOffWithoutRedraw.
                                self okPressed 
                              ]
                       in:self.

    "okButton isReturnButton:true."
    okButton origin:[(width // 4) @ (height - ViewSpacing - okButton height)]
             extent:[(width // 2) @ okButton height]
!

initFormBitmap
    formLabel form:InfoBitmap
! !

!InfoBox methodsFor:'realization'!

show
    "added bell to wake up user"

    device beep.
    super show
!

showAtPointer
    "redefined to show the box with the cursor in the ok-box"

    self fixSize.
    self showAt:(device pointerPosition
                 - (okButton originRelativeTo:self)
                 - ((okButton width // 2) @ (okButton height // 2)) )

! !

!InfoBox methodsFor:'accessing'!

form:aForm
    "define a form to be displayed left of the title
     - usually an exclamation-mark"

    formLabel form:aForm.
    formLabel resize.
    self resize
!

title:aString
    "set the title"

    textLabel label:aString.
    textLabel resize.
    self resize
!

title
    "return the title"

    ^ textLabel label
!

okAction:aBlock
    "define the action to be performed when ok is pressed"

    okAction := aBlock
!

okText:aString
    "define the text in the ok-button"

    okButton label:aString.
    self resize
! !

!InfoBox methodsFor:'private'!

resize
    "resize myself to make everything fit into myself"

    |w h extra|

    w := ViewSpacing + formLabel width + ViewSpacing + textLabel width + ViewSpacing.
    h := ViewSpacing
         + ((formLabel height) max:(textLabel height))
         + ViewSpacing + ViewSpacing
         + okButton height
         + ViewSpacing.

    extra := margin * 2.
    super extent:(w + extra) @ (h + extra)
! !

!InfoBox methodsFor:'user interaction'!

hideAndEvaluate:aBlock
    "make myself invisible and evaluate aBlock"

    self hide.
    aBlock notNil ifTrue:[aBlock value]
!

okPressed
    "user pressed ok-button; make myself invisible and if an action was
     specified do it"

    self hideAndEvaluate:okAction
!

keyPress:aKey x:x y:y
    "return-key dublicates ok-function"

    (aKey == #Return) ifTrue:[self okPressed]
! !
