"
 COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Button subclass:#Toggle
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Views-Interactors'
!

Toggle comment:'

COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

this button changes state whenever pressed and stays pressed until pressed
again. All the main action is in Button, Toggle just redefines buttonpress/
release behavior.

$Header: /cvs/stx/stx/libwidg/Toggle.st,v 1.2 1993-10-13 01:03:53 claus Exp $
written spring/summer 89 by claus
'!

!Toggle methodsFor:'changing state'!

toggleNoAction
    "toggle, but do NOT perform any action - can be used to change a toggle
     under program control (i.e. turn one toggle off from another one)"

    pressed := pressed not.
    self redraw
!

toggle
    "toggle and perform the action"

    enabled ifTrue:[
        pressed := pressed not.
        pressed ifTrue:[
            self level:onLevel.
            pressActionBlock notNil ifTrue:[pressActionBlock value]
        ] ifFalse:[
            self level:offLevel.
            releaseActionBlock notNil ifTrue:[releaseActionBlock value]
        ].
        self redraw
    ]
! !

!Toggle methodsFor:'events'!

buttonPress:button x:x y:y
    button == 1 ifFalse:[
        ^ super buttonPress:button x:x y:y
    ].
    self toggle
!

buttonRelease:button x:x y:y
    button == 1 ifFalse:[
        ^ super buttonRelease:button x:x y:y
    ].
    "ignore"
! !
